# Inverse Problems for Beginners

## Information

Here are some links to packages this tutorial is using:

| What | Where |
| --- | --- |
| PyThia repository | [https://gitlab.com/pythia-uq/pythia](https://gitlab.com/pythia-uq/pythia) |
| PyThia doc | [https://pythia-uq.readthedocs.io](https://pythia-uq.readthedocs.io) |
| emcee doc | [https://emcee.readthedocs.io/](https://emcee.readthedocs.io/) |

## Setup
After cloning the repository, you need to ensure all required python packages are installed.
A specification of all requirements and their respective versions are listed in the `environment.yml` file.
You can use this file to create a new conda environment called `tutorial`, which is ready to execute the files of this repository.
To do so, run the following line in the repositry root (where this README is located):
```sh
conda env create -f environment.yml
```
Then start the environment using `conda activate tutorial`.

## Structure of the Repository

###### `app/`

This directory contains the notebooks you should run.
They are split into three different categories:

| Name | Description |
| --- | --- |
| tutorials | These scripts explain basic usage of theoretical concepts and syntax of common software libraries. |
| exercises | These scripts are meant as exercises for you. You can always use the tutorial scripts for help. |
| solutions | These scripts are the solutions to the respective exercise. Look into them, if you want to check your own approach to the exercises. |

###### `data/`

Data files used for the exercises.

###### `img/`

Images used in the notebooks or in the presentations.

###### `src/`

Utility packages to keep code in the notebooks concise and problem focussed.

## Developper's Note

If you want to commit any changes to the jupyter notebooks, please make sure that the tutorial environment is active.
This way, git only lists changes in notebooks, if the code cells were changed and ignores changes in outputs or meta data.

## Authors and acknowledgment

This repository has been created and is maintained by PTB Group 8.43.
The development of this repository has been partially funded by the EMPIR project 20IND04-ATMOC.
